from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import File, Boolean, Int

Tandem2Pin_V0_1_0 = CommandToolBuilder(tool="tandem2pin", base_command=["tandem2pin"], inputs=[ToolInput(tag="in_output_tab", input_type=File(optional=True), prefix="--outputTab", doc=InputDocumentation(doc="save output in a tab delimited file")), ToolInput(tag="in_output_xml", input_type=File(optional=True), prefix="--outputXML", doc=InputDocumentation(doc="save output in the (deprecated) pin-xml format file")), ToolInput(tag="in_output_xml_stdout", input_type=Boolean(optional=True), prefix="--outputXMLstdout", doc=InputDocumentation(doc="output to stdout in the (deprecated) pin-xml format")), ToolInput(tag="in_matches", input_type=Int(optional=True), prefix="--matches", doc=InputDocumentation(doc="Maximal number of matches to take in consideration\nper spectrum")), ToolInput(tag="in_verbose", input_type=Int(optional=True), prefix="--verbose", doc=InputDocumentation(doc="Set verbosity of output: 0=no processing info,\n5=all, default is 2")), ToolInput(tag="in_aa_freq", input_type=Boolean(optional=True), prefix="--aa-freq", doc=InputDocumentation(doc="Calculate amino acid frequency features")), ToolInput(tag="in_ptm", input_type=Boolean(optional=True), prefix="--PTM", doc=InputDocumentation(doc="Calculate feature for number of post-translational")), ToolInput(tag="in_enzyme", input_type=Boolean(optional=True), prefix="--enzyme", doc=InputDocumentation(doc="Type of enzyme\n'no_enzyme','elastase','pepsin','proteinasek','therm\nolysin','chymotrypsin','lys-n','lys-c','arg-c','asp-\nn','glu-c','trypsin' default='trypsin'")), ToolInput(tag="in_id_with_exp_mass", input_type=Boolean(optional=True), prefix="--id-with-exp-mass", doc=InputDocumentation(doc="Include experimental mass in PSMid for easier\ncorrelation with search engine results.")), ToolInput(tag="in_png_as_ef", input_type=Boolean(optional=True), prefix="--PNGaseF", doc=InputDocumentation(doc="Calculate feature based on N-linked glycosylation\npattern resulting from a PNGaseF treatment.\n(N[*].[ST])")), ToolInput(tag="in_ms_two_file", input_type=File(optional=True), prefix="--ms2-file", doc=InputDocumentation(doc="File containing spectra and retention time. The file\ncould be in mzXML, MS2 or compressed MS2 file.")), ToolInput(tag="in_isotope", input_type=Boolean(optional=True), prefix="--isotope", doc=InputDocumentation(doc="Mass difference calculated to closest isotope mass\nrather than to the average mass.")), ToolInput(tag="in_psm_annotation", input_type=Int(optional=True), prefix="--psm-annotation", doc=InputDocumentation(doc="An anotation scheme used to convert the psms from\nthe search. An example if Q# was used to describe\npyro-glu formation (UNIMOD:28), and S* and T* was\nused to describe phosphorylation (UNIMOD:21), we\nwould use the option -p *:21:#:28")), ToolInput(tag="in_pattern", input_type=Boolean(optional=True), prefix="--pattern", doc=InputDocumentation(doc="Pattern used to identify the decoy PSMs. Default =\n'random'.")), ToolInput(tag="in_databases", input_type=Boolean(optional=True), prefix="--databases", doc=InputDocumentation(doc="Link to the fasta database/s used in the search\nagainst the spectra file/s\n<target.fasta,[decoy.fasta]> (Including this option\nwill add the proteins to the generated pin file).")), ToolInput(tag="in_cleavages", input_type=Boolean(optional=True), prefix="--cleavages", doc=InputDocumentation(doc="Number of allowed miss cleavages used in the search\nengine (default 0)(Only valid when using option -F).")), ToolInput(tag="in_min_length", input_type=Boolean(optional=True), prefix="--min-length", doc=InputDocumentation(doc="Minimum peptide length allowed used in the search\nengine (default 6)(Only valid when using option -F).")), ToolInput(tag="in_max_length", input_type=Boolean(optional=True), prefix="--max-length", doc=InputDocumentation(doc="Maximum peptide length allowed used in the search\nengine (default 40)(Only valid when using option\n-F).")), ToolInput(tag="in_min_mass", input_type=Boolean(optional=True), prefix="--min-mass", doc=InputDocumentation(doc="Minimum peptide mass allowed used in the search\nengine (default 400)(Only valid when using option\n-F).")), ToolInput(tag="in_max_mass", input_type=Boolean(optional=True), prefix="--max-mass", doc=InputDocumentation(doc="Maximum peptide mass allowed used in the search\nengine (default 6000)(Only valid when using option\n-F).\n")), ToolInput(tag="in_file", input_type=File(), position=0, doc=InputDocumentation(doc="-m <number>"))], outputs=[ToolOutput(tag="out_output_tab", output_type=File(optional=True), selector=InputSelector(input_to_select="in_output_tab", type_hint=File()), doc=OutputDocumentation(doc="save output in a tab delimited file")), ToolOutput(tag="out_output_xml", output_type=File(optional=True), selector=InputSelector(input_to_select="in_output_xml", type_hint=File()), doc=OutputDocumentation(doc="save output in the (deprecated) pin-xml format file"))], container=None, version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Tandem2Pin_V0_1_0().translate("wdl", allow_empty_container=True)

